commit 3998d2178d034bcf178281820920b9565108d288
Author: freddy77 <freddy77>
Date:   Sat Jan 9 23:41:52 2010 +0000

    Fix socket error testing for EAGAIN

diff --git a/ChangeLog b/ChangeLog
index 27352ac..b5ead59 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sun Jan 10 00:41:36 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds_sysdep_private.h src/tds/net.c:
+	- Fix socket error testing for EAGAIN
+
 Sat Jan  9 20:04:51 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/test64.c: More verbose
 
@@ -2070,4 +2074,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2928 2010/01/09 19:05:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2929 2010/01/09 23:41:52 freddy77 Exp $
diff --git a/include/tds_sysdep_private.h b/include/tds_sysdep_private.h
index d0eb302..b711448 100644
--- a/include/tds_sysdep_private.h
+++ b/include/tds_sysdep_private.h
@@ -21,7 +21,7 @@
 #ifndef _tds_sysdep_private_h_
 #define _tds_sysdep_private_h_
 
-/* $Id: tds_sysdep_private.h,v 1.30 2010/01/09 09:50:16 freddy77 Exp $ */
+/* $Id: tds_sysdep_private.h,v 1.31 2010/01/09 23:41:52 freddy77 Exp $ */
 
 #undef TDS_RCSID
 #if defined(__GNUC__) && __GNUC__ >= 3
@@ -84,6 +84,7 @@ void _tds_socket_done(void);
 
 #define TDSSOCK_EINTR WSAEINTR
 #define TDSSOCK_EINPROGRESS WSAEWOULDBLOCK
+#define TDSSOCK_WOULDBLOCK(e) ((e)==WSAEWOULDBLOCK)
 #define sock_errno WSAGetLastError()
 #define sock_strerror(n) tds_prwsaerror(n)
 #ifndef __MINGW32__
@@ -130,6 +131,14 @@ typedef DWORD pid_t;
 #define TDSSOCK_EINPROGRESS EINPROGRESS
 #endif
 
+#ifndef TDSSOCK_WOULDBLOCK
+# if defined(EWOULDBLOCK) && EAGAIN != EWOULDBLOCK
+#  define TDSSOCK_WOULDBLOCK(e) ((e)==EAGAIN||(e)==EWOULDBLOCK)
+# else
+#  define TDSSOCK_WOULDBLOCK(e) ((e)==EAGAIN)
+# endif
+#endif
+
 #ifndef INITSOCKET
 #define INITSOCKET()	0
 #endif /* !INITSOCKET */
diff --git a/src/tds/net.c b/src/tds/net.c
index b664db2..dfc686d 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -107,7 +107,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.98 2010/01/09 09:50:16 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.99 2010/01/09 23:41:52 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL) && !defined(C_INTERIX)
@@ -276,7 +276,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 		tds->oserr = sock_errno;
 		tdsdump_log(TDS_DBG_ERROR, "tds_open_socket: connect(2) returned \"%s\"\n", sock_strerror(sock_errno));
 #if DEBUGGING_CONNECTING_PROBLEM
-		if (sock_errno != ECONNREFUSED && sock_errno != ENETUNREACH && sock_errno != EINPROGRESS) {
+		if (sock_errno != ECONNREFUSED && sock_errno != ENETUNREACH && sock_errno != TDSSOCK_EINPROGRESS) {
 			tdsdump_dump_buf(TDS_DBG_ERROR, "Contents of sockaddr_in", &sin, sizeof(sin));
 			tdsdump_log(TDS_DBG_ERROR, 	" sockaddr_in:\t"
 							      "%s = %x\n" 
@@ -500,7 +500,7 @@ tds_goodread(TDSSOCKET * tds, unsigned char *buf, int buflen, unsigned char unfi
 
 			len = READSOCKET(tds->s, buf + got, buflen);
 
-			if (len < 0 && sock_errno == EAGAIN)
+			if (len < 0 && TDSSOCK_WOULDBLOCK(sock_errno))
 				continue;
 			/* detect connection close */
 			if (len <= 0) {
@@ -509,7 +509,7 @@ tds_goodread(TDSSOCKET * tds, unsigned char *buf, int buflen, unsigned char unfi
 				return -1;
 			}
 		} else if (len < 0) {
-			if (sock_errno == EAGAIN) /* shouldn't happen, but OK */
+			if (TDSSOCK_WOULDBLOCK(sock_errno)) /* shouldn't happen, but OK */
 				continue;
 			tdserror(tds->tds_ctx, tds, TDSEREAD, sock_errno);
 			tds_close_socket(tds);
@@ -705,7 +705,7 @@ tds_goodwrite(TDSSOCKET * tds, const unsigned char *buffer, size_t len, unsigned
 				continue;
 			}
 			
-			if (0 == nput || sock_errno == EAGAIN)
+			if (0 == nput || TDSSOCK_WOULDBLOCK(sock_errno))
 				continue;
 
 			assert(nput < 0);
@@ -716,7 +716,7 @@ tds_goodwrite(TDSSOCKET * tds, const unsigned char *buffer, size_t len, unsigned
 			return -1;
 
 		} else if (rc < 0) {
-			if (sock_errno == EAGAIN) /* shouldn't happen, but OK, retry */
+			if (TDSSOCK_WOULDBLOCK(sock_errno)) /* shouldn't happen, but OK, retry */
 				continue;
 			tdsdump_log(TDS_DBG_NETWORK, "select(2) failed: %d (%s)\n", sock_errno, sock_strerror(sock_errno));
 			tdserror(tds->tds_ctx, tds, TDSEWRIT, sock_errno);

